<?xml version="1.0" encoding="UTF-8" ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<title><@s.text name="link.searchBooks" /></title>
	<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />
</head>

<body>
	<h2><@s.text name="link.searchBooks" /></h2>

	<p>
	<#if searchType == 1>
		<@s.text name="text.searchSummary">
			<@s.param value="%{getText('text.searchByName')}" />
			<@s.param value="name" />
		</@s.text>
	<#elseif searchType == 2>
		<@s.text name="text.searchSummary">
			<@s.param value="%{getText('text.searchByAuthors')}" />
			<@s.param value="name" />
		</@s.text>
	<#elseif searchType == 3>
		<@s.text name="text.availableBooks" />
	</#if>:
	</p>
	
	<#if (books?exists && books?has_content)>
		<div id="bookSearchResult">
			<div class="info"><div class="title"><@s.text name="text.book" /></div></div>
			<div class="actions"><div class="title"><@s.text name="text.status" /></div></div>
			<div class="footer"></div>
		</div>
				
		<#list books as book>
			<#-- Determines if the book is available or not. -->
			<#if book.borrowed>
				<#assign status = "NotAvailable" />
				<#assign action = "borrowBook/return!input.action" />
			<#else>
				<#assign status = "Available" />
				<#assign action = "borrowBook/borrow!input.action" />
			</#if>
	
			<div id="bookSearchResult">
				<div class="info">
					<img border="0" src="${base}/resources/images/iconBook32x32.png" width="32" height="32" alt="${book.name}" title="${book.name}" align="left" />
					${book.name}<br />
					<span class="authors">${book.authors}</span>
					<#if book.borrowed>
						<br />
						<span class="loanInfo">
						<@s.text name="text.loanInfo">
							<@s.param value="'${book.currentLoan.borrower.name}'" />
							<@s.param value="'${book.currentLoan.loanDate?datetime?string.medium_short}'" />
						</@s.text></span>
					</#if>
				</div>
				<div class="actions">
					<a href="${base}/${action}?book.id=${book.id}"><img border="0" src="${base}/resources/images/icon${status}16x16.png" width="16" height="16" alt="<@s.text name='text.book${status}' />" title="<@s.text name='text.book${status}' />" /></a>
				</div>
				<div class="footer"></div>
			</div>
		</#list>
	<#else>
		<p><@s.text name="text.noBooksFound" /></p>
	</#if>
</body>

</html>
