/** Bookshelf - BorrowBookService.java - 15/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.bookshelf.domain.Loan;
import net.java.dev.esjug.bookshelf.domain.Member;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public interface BorrowBookService {
	/**
	 * Executes the use case "Borrow Book".
	 * 
	 * @param borrower Member that is borrowing the book.
	 * @param book Book that is being borrowed.
	 * @return The book loan.
	 */
	Loan borrowBook(Member borrower, Book book);
	
	/**
	 * Executes the use case "Return book".
	 * 
	 * @param loan Loan that associates the member and the book that will be returned.
	 */
	void returnBook(Loan loan);
	
	/**
	 * Executes the use case "View Loan".
	 * 
	 * @param loanId The id of the loan you want to view the details.
	 * @return The loan object.
	 */
	Loan viewLoan(Long loanId);
}
