/** Bookshelf - BorrowBookServiceImpl.java - 15/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.bookshelf.domain.Loan;
import net.java.dev.esjug.bookshelf.domain.Member;
import net.java.dev.esjug.bookshelf.persistence.LoanDAO;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public class BorrowBookServiceImpl implements BorrowBookService {
	/** DAO for Loan objects. */
	private LoanDAO loanDAO;
	
	/**
	 * Setter for loanDAO.
	 * @param loanDAO The loanDAO to set.
	 */
	public void setLoanDAO(LoanDAO loanDAO) {
		this.loanDAO = loanDAO;
	}

	/* @see net.java.dev.esjug.bookshelf.application.BorrowBookService#borrowBook(net.java.dev.esjug.bookshelf.domain.Member, net.java.dev.esjug.bookshelf.domain.Book) */
	public Loan borrowBook(Member borrower, Book book) {
		Loan loan = new Loan(borrower, book);
		loanDAO.save(loan);
		return loan;
	}

	/* @see net.java.dev.esjug.bookshelf.application.BorrowBookService#returnBook(net.java.dev.esjug.bookshelf.domain.Loan) */
	public void returnBook(Loan loan) {
		loan.returnBook();
		loanDAO.save(loan);
	}

	/* @see net.java.dev.esjug.bookshelf.application.BorrowBookService#viewLoan(java.lang.Long) */
	public Loan viewLoan(Long loanId) {
		return loanDAO.retrieveById(loanId);
	}
}
