/** Bookshelf - RegisterBookServiceImpl.java - 11/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import java.util.Collection;
import java.util.TreeSet;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.bookshelf.persistence.BookDAO;
import net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public class RegisterBookServiceImpl extends CrudServiceSupport<Book, Long> implements RegisterBookService {
	/** Serialization id. */
	private static final long serialVersionUID = 758094808635099050L;

	/** DAO for Book objects. */
	private BookDAO bookDAO;

	/**
	 * Setter for bookDAO.
	 * @param bookDAO The bookDAO to set.
	 */
	public void setBookDAO(BookDAO bookDAO) {
		this.bookDAO = bookDAO;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doCreate(java.lang.Object) */
	@Override
	protected Book doCreate(Book valueObject) {
		Book object = new Book(valueObject.getName(), valueObject.getAuthors());
		bookDAO.save(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doDelete(java.lang.Object) */
	@Override
	protected Book doDelete(Long id) {
		Book object = bookDAO.retrieveById(id);
		bookDAO.delete(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doRetrieve(java.lang.Object) */
	@Override
	protected Book doRetrieve(Long id) {
		Book object = bookDAO.retrieveById(id);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doUpdate(java.lang.Object, java.lang.Object) */
	@Override
	protected Book doUpdate(Long id, Book valueObject) {
		Book object = bookDAO.retrieveById(id);
		object.copy(valueObject);
		bookDAO.save(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudService#list() */
	public Collection<Book> list() {
		return new TreeSet<Book>(bookDAO.retrieveAll());
	}
}

