/** Bookshelf - RegisterMemberServiceImpl.java - 11/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import java.util.Collection;
import java.util.TreeSet;

import net.java.dev.esjug.bookshelf.domain.Member;
import net.java.dev.esjug.bookshelf.persistence.MemberDAO;
import net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public class RegisterMemberServiceImpl extends CrudServiceSupport<Member, Long> implements RegisterMemberService {
	/** Serialization id. */
	private static final long serialVersionUID = 2084485434161394344L;
	
	/** DAO for Member objects. */
	private MemberDAO memberDAO;

	/**
	 * Setter for memberDAO.
	 * @param memberDAO The memberDAO to set.
	 */
	public void setMemberDAO(MemberDAO memberDAO) {
		this.memberDAO = memberDAO;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doCreate(java.lang.Object) */
	@Override
	protected Member doCreate(Member valueObject) {
		Member object = new Member(valueObject.getName(), valueObject.getEmail(), valueObject.getPhone());
		memberDAO.save(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doDelete(java.lang.Object) */
	@Override
	protected Member doDelete(Long id) {
		Member object = memberDAO.retrieveById(id);
		memberDAO.delete(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doRetrieve(java.lang.Object) */
	@Override
	protected Member doRetrieve(Long id) {
		Member object = memberDAO.retrieveById(id);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudServiceSupport#doUpdate(java.lang.Object, java.lang.Object) */
	@Override
	protected Member doUpdate(Long id, Member valueObject) {
		Member object = memberDAO.retrieveById(id);
		object.copy(valueObject);
		memberDAO.save(object);
		return object;
	}

	/* @see net.java.dev.esjug.util.frameworks.crud.CrudService#list() */
	public Collection<Member> list() {
		return new TreeSet<Member>(memberDAO.retrieveAll());
	}
}

