/** Bookshelf - SearchBooksService.java - 15/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import java.util.Collection;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.bookshelf.domain.Loan;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public interface SearchBooksService {
	/**
	 * Retrieves all books that match the given name.
	 *  
	 * @param name Name or part of the name of the desired book.
	 * @return Books that match the criteria.
	 */
	Collection<Book> searchByName(String name);

	/**
	 * Retrieves all books whose authors match the given name.
	 * 
	 * @param Name or part of the name of one of the authors of the desired book.
	 * @return Books that match the criteria.
	 */
	Collection<Book> searchByAuthorName(String name);
	
	/**
	 * Retrieves all books that are not currently borrowed.
	 * 
	 * @return Books that are not currently borrowed.
	 */
	Collection<Book> listAvailableBooks();
	
	/**
	 * Retrieves all books that are currently borrowed, together with its loan information.
	 * 
	 * @return Loans that are currently open (i.e. the book hasn't been returned).
	 */
	Collection<Loan> listBorrowedBooks();
}
