/** Bookshelf - SearchBooksServiceImpl.java - 15/03/2007 */
package net.java.dev.esjug.bookshelf.application;

import java.util.Collection;
import java.util.TreeSet;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.bookshelf.domain.Loan;
import net.java.dev.esjug.bookshelf.persistence.BookDAO;
import net.java.dev.esjug.bookshelf.persistence.LoanDAO;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public class SearchBooksServiceImpl implements SearchBooksService {
	/** DAO for Book objects. */
	private BookDAO bookDAO;
	
	/** DAO for Loan objects. */
	private LoanDAO loanDAO;
	
	/**
	 * Setter for bookDAO.
	 * @param bookDAO The bookDAO to set.
	 */
	public void setBookDAO(BookDAO bookDAO) {
		this.bookDAO = bookDAO;
	}

	/**
	 * Setter for loanDAO.
	 * @param loanDAO The loanDAO to set.
	 */
	public void setLoanDAO(LoanDAO loanDAO) {
		this.loanDAO = loanDAO;
	}

	/* @see net.java.dev.esjug.bookshelf.application.SearchBooksService#searchByAuthorName(java.lang.String) */
	public Collection<Book> searchByAuthorName(String name) {
		return new TreeSet<Book>(bookDAO.retrieveByAuthorName(name));
	}

	/* @see net.java.dev.esjug.bookshelf.application.SearchBooksService#searchByName(java.lang.String) */
	public Collection<Book> searchByName(String name) {
		return new TreeSet<Book>(bookDAO.retrieveByName(name));
	}

	/* @see net.java.dev.esjug.bookshelf.application.SearchBooksService#listAvailableBooks() */
	public Collection<Book> listAvailableBooks() {
		return new TreeSet<Book>(bookDAO.retrieveAvailableBooks());
	}

	/* @see net.java.dev.esjug.bookshelf.application.SearchBooksService#listBorrowedBooks() */
	public Collection<Loan> listBorrowedBooks() {
		return new TreeSet<Loan>(loanDAO.retrieveOpenLoans());
	}
}
