/** Bookshelf - Member.java - 10/03/2007 */
package net.java.dev.esjug.bookshelf.domain;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import net.java.dev.esjug.util.persistence.PersistentObjectSupport;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
@Entity
public class Member extends PersistentObjectSupport<Long, Long> implements Comparable<Member> {
	/** Serialization id. */
	private static final long serialVersionUID = -3271286373676221543L;

	/** Full name. */
	@Basic @Column(length = 50)
	private String name;
	
	/** E-mail. */
	@Basic @Column(length = 100)
	private String email;
	
	/** Contact phone. */
	@Basic @Column(length = 200)
	private String phone;
	
	/** Register date. */
	@Temporal(TemporalType.DATE)
	private Date registerDate = new Date(System.currentTimeMillis());
	
	/** Empty onstructor. */
	public Member() { }

	/**
	 * Constructor.
	 * @param name Member name.
	 * @param email Member email.
	 * @param phone Member contact phone.
	 */
	public Member(String name, String email, String phone) {
		this.name = name;
		this.email = email;
		this.phone = phone;
	}

	/**
	 * Getter for email.
	 * @return The email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Setter for email.
	 * @param email The email to set.
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Getter for name.
	 * @return The name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter for name.
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter for phone.
	 * @return The phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * Setter for phone.
	 * @param phone The phone to set.
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * Getter for registerDate.
	 * @return The registerDate
	 */
	public Date getRegisterDate() {
		return registerDate;
	}

	/**
	 * Setter for registerDate.
	 * @param registerDate The registerDate to set.
	 */
	@SuppressWarnings("unused")
	private void setRegisterDate(Date registerDate) {
		this.registerDate = registerDate;
	}

	/**
	 * Copies data from another object.
	 * @param member The object from which the data is copied.
	 */
	public void copy(Member member) {
		this.name = member.name;
		this.email = member.email;
		this.phone = member.phone;
	}

	/* @see java.lang.Comparable#compareTo(java.lang.Object) */
	public int compareTo(Member object) {
		return name.compareTo(object.name);
	}
}