/** Bookshelf - BookDAO.java - 11/03/2007 */
package net.java.dev.esjug.bookshelf.persistence;

import java.util.Collection;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.util.persistence.BaseDAO;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public interface BookDAO extends BaseDAO<Book, Long> {
	/**
	 * Retrieves all books that contain the given name as part of the authors names.
	 * 
	 * @param name Name or part of the name of one of the authors.
	 * @return A collection of books that match the criteria.
	 */
	Collection<Book> retrieveByAuthorName(String name);

	/**
	 * Retrieves all books that contain the given name as part of its title.
	 * 
	 * @param name Title or part of the title of the book.
	 * @return A collection of books that match the criteria.
	 */
	Collection<Book> retrieveByName(String name);

	/**
	 * Retrieves all books that are not currently borrowed by any members.
	 * @return A collection of available books.
	 */
	Collection<Book> retrieveAvailableBooks();
}
