/** Bookshelf - HibernateSpringBookDAO.java - 11/03/2007 */
package net.java.dev.esjug.bookshelf.persistence;

import java.util.Collection;

import net.java.dev.esjug.bookshelf.domain.Book;
import net.java.dev.esjug.util.persistence.HibernateSpringBaseDAO;

/**
 * TODO: documentation.
 *
 * @author Vitor Souza (vitorsouza@gmail.com)
 */
public class HibernateSpringBookDAO extends HibernateSpringBaseDAO<Book, Long> implements BookDAO {
	/* @see net.java.dev.esjug.util.persistence.HibernateSpringBaseDAO#getDomainClass() */
	@Override
	protected Class getDomainClass() {
		return Book.class;
	}

	/* @see net.java.dev.esjug.bookshelf.persistence.BookDAO#searchByAuthorName(java.lang.String) */
	@SuppressWarnings("unchecked")
	public Collection<Book> retrieveByAuthorName(String name) {
		return getHibernateTemplate().findByNamedQueryAndNamedParam("book.searchByAuthorName", "name", "%" + name + "%");
	}

	/* @see net.java.dev.esjug.bookshelf.persistence.BookDAO#searchByName(java.lang.String) */
	@SuppressWarnings("unchecked")
	public Collection<Book> retrieveByName(String name) {
		return getHibernateTemplate().findByNamedQueryAndNamedParam("book.searchByName", "name", "%" + name + "%");
	}

	/* @see net.java.dev.esjug.bookshelf.persistence.BookDAO#retrieveAvailableBooks() */
	@SuppressWarnings("unchecked")
	public Collection<Book> retrieveAvailableBooks() {
		return getHibernateTemplate().findByNamedQuery("book.retrieveAvailableBooks");
	}
}
